import {Component, OnInit} from '@angular/core';
import {CreateSessionRequest, CreateSessionResponse, TokenService} from '../../../gen';
import {AuthService} from '../../services/auth.service';
import {Router} from '@angular/router';

@Component({
  selector: 'app-login',
  standalone: false,

  templateUrl: './login.component.html',
  styleUrl: './login.component.css'
})
export class LoginComponent implements OnInit {
  createSessionRequest: CreateSessionRequest = {
    username: "",
    password: ""
  }

  constructor(private tokenService: TokenService, private authService: AuthService, private router: Router) {
  }

  ngOnInit(): void {
    if (this.authService.getToken() != null) {
      this.router.navigate(["/"]);
    }
  }

  onSubmit(): void {
    this.tokenService.createToken(this.createSessionRequest).subscribe({
      next: (response: CreateSessionResponse): void => {
        this.authService.setToken(response.token);
        this.router.navigate(["/"]);
      },
      error: (err: Error): void => {
        console.log(err);
      }
    });
  }
}
